; :	shilow@ukr.net
; :		 2014
; :	avm
; :	3
;  : 	avm.asm, avm.spl7, avm.lay6
;  AVR:	ATtiny24A
;  : 8MHz,  RC-
;  :  
; . ReadMe.txt
;   " 5"

;******************************
; 
.nolist
.include "tn24Adef.inc"
.list

;******************************
; 
.def job0	= r0
.def job1	= r1
.def job2	= r2
.def job3	= r3
.def LED1	= r4
.def LED2	= r5
.def LED3	= r6
.def LED4	= r7
; r8
; r9
; r10
; r11
; r12
; r13
.def msrL	= r14	;  
.def msrH	= r15
.def temp	= r16	;   
.def tmp1	= r17
.def cnt1	= r18	;  
.def cnt2	= r19	;   
.def LEDN	= r20
; r21
; r22
.def bAddr	= r23	;      
.def bIdx	= r24	;  
.def flags	= r25
; r26 XL OUT_NIBBL
; r27 XH
; r28 YL   
; r29 YH
; r30 ZL OUT_NIBBL, BIN2BCD
; r31 ZH
;******************************
; 
.equ AtBCD0	= 0	;address of job0
.equ AtBCD2	= 2	;address of job2
.equ AtLED1	= 4	;address of LED1
.equ MSEK100	= 7	; 7bit of flags == 0.1 sek
.equ NEED_DOT	= 6	;  
.equ DISP_PORT	= PORTA
.equ DISP_DDR	= DDRA
.equ LA1	= 4
.equ LA2	= 5
.equ LA3	= 6
.equ LA4	= 7
.equ IND_LA	= (1<<LA1)|(1<<LA2)|(1<<LA3)|(1<<LA4)
.equ SER_PORT	= PORTB
.equ SER_DDR	= DDRB
.equ SCK	= 0
.equ DATA	= 1
.equ LOCK	= 2
.equ T1DIVL	= 0x8F
.equ T1DIVH	= 0xFD	; 0x10000-8MHz/64/200Hz
.equ VREF	= 500	;   * 10 
.equ SPH	= 0x3e
.equ DOT_BIT	= 5	; bit5 -- 
.equ BuffSize	= 16	;    
.equ BuffShift	= 4	;        

;******************************
; 
;    SREG  R16
.MACRO PUSHF
	PUSH	R16
	IN	R16,SREG
	PUSH	R16
.ENDM

;    SREG  R16 
.MACRO POPF
	POP	R16
	OUT	SREG,R16
	POP	R16
.ENDM

;******************************
;   
.DSEG
.ORG	SRAM_START
;Display:	.byte 4 ; 4   
Buffer:		.byte 2*BuffSize

;******************************
;   EEPROM
;.ESEG
;smpl1:		.DW	0x0000	; sample 1
;smpl2:		.DB	0x05	; sample 2

;******************************
;  
.CSEG
.ORG 0
;******************************
;   
	rjmp	RESET		; Reset Handler
	reti;jmp	INT0		; IRQ0 Handler
	reti;jmp	PCINT0		; PCINT0 Handler
	reti;jmp	PCINT1		; PCINT1 Handler
	reti;jmp	WDT		; Watchdog Interrupt Handler
	reti;jmp	TIM1_CAPT	; Timer1 Capture Handler
	reti;jmp	TIM1_COMPA	; Timer1 Compare A Handler
	reti;jmp	TIM1_COMPB	; Timer1 Compare B Handler
	rjmp	TIM1_OVF	; Timer1 Overflow Handler
	reti;jmp	TIM0_COMPA	; Timer0 Compare A Handler
	reti;jmp	TIM0_COMPB	; Timer0 Compare B Handler
	reti;jmp	TIM0_OVF	; Timer0 Overflow Handler
	reti;jmp	ANA_COMP	; Analog Comparator Handler
	rjmp	ADCC		; ADC Conversion Handler
;	rjmp	EE_RDY		; EEPROM Ready Handler
;	rjmp	USI_STR		; USI STart Handler
;	rjmp	USI_OVF		; USI Overflow Handler

;******************************
;;;;;  
RESET:
	ldi	temp,high(RAMEND); Main program start
	out	SPH,temp
	ldi	temp,low(RAMEND)
	out	SPL,temp; Set Stack Pointer to top of RAM
; . ,  
	ldi	temp,1<<ACD
	out	ACSR,temp
;  .  - Vcc,  1,  . temp=0b00100010
	ldi	temp,1<<MUX0
	out	ADMUX,temp
	ldi	temp,(1<<ADEN)|(1<<ADSC)|(6<<ADPS0)
	out	ADCSRA,temp
; timer1 -  200 ,   8, =64
	ldi	temp,(3<<CS10)
	out	TCCR1B,temp
	ldi	temp,T1DIVH
	out	TCNT1H,temp
	ldi	temp,T1DIVL
	out	TCNT1L,temp	;   1
;    
	ldi	temp,1<<TOIE1
	out	TIMSK1,temp
; init
	ldi	LEDN,0b11101111	;  
	ldi	temp,IND_LA
	out	DISP_DDR,temp
	out	DISP_PORT,temp
	ldi	temp,(1<<SCK)|(1<<DATA)|(1<<LOCK)
	out	SER_DDR,temp
	clr	YH
	ldi	YL,AtLED1	;   1- 
	ldi	temp,0x30
	mov	LED1,temp
	mov	LED2,temp
	mov	LED3,temp
	mov	LED4,temp
	ldi	bAddr,low(Buffer)
	clr	bIdx
; Enable interrupts
	sei
;******************************
;;;;;  
BEGIN:
;;;    
	clr	msrL
	clr	msrH		;   
	ldi	cnt2,16		;   
	sbi	ADCSRA,ADATE	;  free running mode
	sbi	ADCSRA,ADIE	;    
	sbi	ADCSRA,ADSC	;  .  
ML1:
;	rjmp	PC+1		; nop x 2 -- 1 world 2 takta.  sleep?
	rcall	WAIT_IRQ
	tst	cnt2		;       16 
	brne	ML1
	cbi	ADCSRA,ADIE	;    
	cbi	ADCSRA,ADATE	; stop free running mode
	lsr	msrH
	ror	msrL
	lsr	msrH
	ror	msrL		;    2^2
	;    Vref    4096
	ldi	temp,low(VREF)
	ldi	tmp1,high(VREF)
	rcall	MPY16U
	lsr	job1		;  job0 ==   256
	ror	job0
	lsr	job1
	ror	job0
;;	lsr	job1
;;	ror	job0
;;	lsr	job1
;;	ror	job0		;   16,    4096
;	ldi	cnt1,4
;ML2:	lsr	job2
;	ror	job1
;	dec	cnt1
;	brne	ML2
;	mov	msrL,job0
;	mov	msrH,job1	;  MSR -   10
;!!!    
;; --    4 ==    4.
;;        400    100 --   .
;     .

;      job1:job0


;;; 
	;   
	mov	XL,bAddr
	clr	XH
	st	X+,job0
	st	X,job1		; 
	sbiw	X,1		;     --   
	clr	msrL
	clr	msrH

	;  -    
	ldi	cnt1,BuffSize
BuffSummarize:
	ld	temp,X+
	add	msrL,temp
	ld	temp,X+
	adc	msrH,temp
	inc	bIdx
	cpi	bIdx,BuffSize
	brne	BuffChkCnt
	ldi	XL,low(Buffer)
	clr	bIdx
BuffChkCnt:
	dec	cnt1
	brne	BuffSummarize

	adiw	X,2		;   -   
	inc	bIdx
	cpi	bIdx,BuffSize
	brne	BuffAddrSave
	ldi	XL,low(Buffer)
	clr	bIdx
BuffAddrSave:
	mov	bAddr,XL	;    

	;    msr    . :
	ldi	cnt1,BuffShift
BuffDivide:
	lsr	msrH
	ror	msrL
	dec	cnt1
	brne	BuffDivide
;   msr    .
;       .
	

;;;  msr        
	rcall	bin2BCD16
	; 4    job1:job0
	ldi	XL,AtLED1
	clr	XH
	mov	temp,job1
	swap	temp
	;    0
	andi	temp,0x0F	;   
	tst	temp
	brne	MakeDigit3
	ldi	temp,0xFF	;   
	st	X+,temp
	rjmp	MakeDigit2
MakeDigit3:
	rcall	OUT_NIBBL	;  3, 
MakeDigit2:
	mov	temp,job1
	sbr	flags,1<<NEED_DOT
	rcall	OUT_NIBBL	;  2, 
	cbr	flags,1<<NEED_DOT
	mov	temp,job0
	swap	temp
	rcall	OUT_NIBBL	;  1, 
	mov	temp,job0
	rcall	OUT_NIBBL	;  0, 

;;;  
	rjmp	BEGIN

;******************************
;;;;; 

;******************************
;   - ...   
WAIT_IRQ:
	ldi	temp,1<<SE
	out	MCUCR,temp	;   
	sleep			; .
	clr	temp
	out	MCUCR,temp	;  
	ret

;******************************
;    8   temp,  cnt1
LEDOUT:
	ldi	cnt1,8		;  
LO1:	cbi	SER_PORT,SCK	; SCK=0
	lsl	temp		;    
	brcc	LO0		;    0  
	sbi	SER_PORT,DATA	;  1
	rjmp	LOE
LO0:	cbi	SER_PORT,DATA	;  0
LOE:	sbi	SER_PORT,SCK	; SCK=1,  
	dec	cnt1
	brne	LO1
	ret

;******************************
;**    temp    7-         X
OUT_NIBBL:
	ldi	ZL,low(LEDnd*2)
	ldi	ZH,high(LEDnd*2);    
	andi	temp,0x0F	;   .  
	add	ZL,temp
	adc	ZH,XH		;  
	lpm	temp,Z		;  
	sbrc	flags,NEED_DOT	;  ?
	cbr	temp,1<<DOT_BIT	;  
	st	X+,temp		;     
	ret

;******************************
;   16- ,  3 , 
;  msrH:msrL,  tmp1:temp,  job2:job1:job0
;  cnt1
MPY16U:
	clr	job2		;clear 1 highest bytes of result
	ldi	cnt1,16		;init loop counter
m16u_1:	lsr	tmp1
	ror	temp
	brcc	noad8		;if bit 0 of multiplier set
	add	job1,msrL	;add multiplicand Low to byte 1 of res
	adc	job2,msrH	;add multiplicand high to byte 2 of res
noad8:	ror	job2		;shift right result byte 2
	ror	job1		;rotate right result byte 1
	ror	job0		;rotate result byte 0 and multiplier Low
	dec	cnt1		;decrement loop counter
	brne	m16u_1		;if not done, loop more
	ret

;******************************
;* This subroutine converts a 16-bit number (msrH:msrL) to a 5-digit 
;* packed BCD number represented by 3 bytes (job2:job1:job0).
;* MSD of the 5-digit number is placed in the lowermost nibble of job2.
bin2BCD16:
	ldi	cnt1,16		;Init loop counter
	clr	job2		;clear result (3 bytes)
	clr	job1
	clr	job0
	clr	ZH		;clear ZH
bBCDx_1:lsl	msrL		;shift input value
	rol	msrH		;through all bytes
	rol	job0
	rol	job1
	rol	job2
	dec	cnt1		;decrement loop counter
	brne	bBCDx_2		;if counter not zero
	ret			;   return
bBCDx_2:ldi	ZL,AtBCD2+1	;Z points to result MSB + 1
bBCDx_3:ld	temp,-Z		;get (Z) with pre-decrement
	subi	temp,-$03	;add 0x03
	sbrc	temp,3		;if bit 3 not clear
	st	Z,temp		;	store back
	ld	temp,Z		;get (Z)
	subi	temp,-$30	;add 0x30
	sbrc	temp,7		;if bit 7 not clear
	st	Z,temp		;	store back
	cpi	ZL,AtBCD0	;done all three?
	brne	bBCDx_3		;loop again if not
	rjmp	bBCDx_1


;******************************
;;;;;  

;******************************
; Timer1 Overflow Handler
TIM1_OVF:
;    7-  
;  100     
	PUSHF

T1L1:
	;***************************
	;     
	in	temp,DISP_PORT
	ori	temp,IND_LA	;    
	out	DISP_PORT,temp	;   
	cbi	SER_PORT,LOCK	;  
	ld	temp,Y+		;   -  , =+1
	rcall	LEDOUT		;     
	sbi	SER_PORT,LOCK	;  0  1 --    
	in	temp,DISP_PORT
	ori	temp,IND_LA
	and	temp,LEDN
	out	DISP_PORT,temp	;   
	lsl	LEDN		;  -  
	brlo	T1L2		;   ?  
	ldi	LEDN,0b11101111	; ,   
	ldi	YL,AtLED1	;   1- 
T1L2:
	ldi	temp,T1DIVH
	out	TCNT1H,temp
	ldi	temp,T1DIVL
	out	TCNT1L,temp	;   1

	POPF
	reti


;***************************
; ADC Conversion Handler
;   ,  .
ADCC:
	in	temp,ADCL
	add	msrL,temp
	in	temp,ADCH
	adc	msrH,temp
	dec	cnt2
	reti

;***************************
;    0-9    ,  .     5
LEDnd:	.DB	0x30,0xF3,0x2A,0xA2,0xE1,0xA4,0x24,0xF2,0x20,0xA0

.exit

INT0:		; IRQ0 Handler
	reti

PCINT0:		; PCINT0 Handler
	reti

PCINT1:		; PCINT1 Handler
	reti

WDT:		; Watchdog Interrupt Handler
	reti

TIM1_CAPT:	; Timer1 Capture Handler
	reti

TIM1_COMPA:	; Timer1 Compare A Handler
	reti

TIM1_COMPB:	; Timer1 Compare B Handler
	reti

TIM0_COMPA:	; Timer0 Compare A Handler
	reti

TIM0_COMPB:	; Timer0 Compare B Handler
	reti

TIM0_OVF:	; Timer0 Overflow Handler
	reti

ANA_COMP:	; Analog Comparator Handler
	reti

EE_RDY:		; EEPROM Ready Handler
	reti

USI_STR:	; USI STart Handler
	reti

USI_OVF:	; USI Overflow Handler
	reti

;
.exit
